
Redmine - Defect #12981

Wiki self-link with anchor looks strange in "preview" section.

2013-01-25 12:26 - Vadim Pushtaev

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Text formatting Estimated time: 0.00 hour

Target version:    

Resolution: Wont fix Affected version: 2.2.2

Description

My page named Wiki contains link [[Wiki#Section]]. It produces this HTML: <a href="#Section">Wiki</a> that looks great on the

page, but look strange in preview section, while editing this page. In that case it directs me to /projects/project1/wiki/Wiki/edit#Section

that is obviously wrong.

Self-link is considered like special case by this piece of code (app/helpers/application_helper.rb):

def parse_wiki_links

# ...

url = if anchor.present? && wiki_page.present? && (obj.is_a?(WikiContent) || obj.is_a?(WikiContent

::Version)) && obj.page == wiki_page

  "##{anchor}" 

else

 As you can see, obj.page == wiki_page is not enough to make link local.

Related issues:

Related to Redmine - Patch #16313: Allow to link to an anchor of the current ... Closed

History

#1 - 2013-01-25 14:31 - Etienne Massip

Yes and no, links generated in preview are not really supposed to be functional so the case is not taken into account.

#2 - 2013-01-27 09:27 - wei hui

- File Screenshot_2013-01-21-09-14-40.png added

#3 - 2013-01-27 11:05 - Jean-Philippe Lang

- File deleted (Screenshot_2013-01-21-09-14-40.png)

#4 - 2013-01-27 12:34 - Vadim Pushtaev

Is it really necessary to make link local? I mean, my browser doesn't refresh page anyway, even if full link to the same page is provided.

#5 - 2013-01-27 14:54 - Etienne Massip

ItLs useful for HTML export.

#6 - 2013-11-14 08:29 - Vadim Pushtaev

- File 12981.diff added

I believe the appropriate strategy here is to never use local links in preview sections, it's pointless.

app/views/common/_preview.html.erb:

-<%= textilizable @text, :attachments => @attachments, :object => @previewed %>

+<%= textilizable @text, :attachments => @attachments, :object => @previewed, :wiki_links => :full %>

 Patch with tests included.
#7 - 2013-11-14 08:29 - Vadim Pushtaev

- Status changed from New to Resolved

#8 - 2021-06-12 10:38 - Go MAEDA

- Status changed from Resolved to Closed

- Resolution set to Wont fix

Please use [[#Section]] instead of [[Wiki#Section]] when you want to make a link to an anchor on the current page. The syntax is allowed since

Redmine 4.0.0 (#16313). It should work as you expect.

#9 - 2021-06-12 10:38 - Go MAEDA

- Related to Patch #16313: Allow to link to an anchor of the current wikipage added

Files

12981.diff 5.56 KB 2013-11-14 Vadim Pushtaev
